#include "LogicGateNode.h"

#include "Path.h"
#include "PathNode.h"
#include "CircleNode.h"

#include "LogicGate.h"
#include "LogicGatePrimitiveShapes.h"

LogicGateNode::LogicGateNode(const Transform& transform)
	: AbstractVisualNode(transform)
{

}

void LogicGateNode::setContent(LogicGate* content)
{
	mContent = content;
	mContentDirty = true;
}

void LogicGateNode::update(SceneInfo* sceneInfo)
{
	if (mContentDirty)
	{
		createOrUpdateGeometry(sceneInfo);
		mContentDirty = false;
	}
}

void LogicGateNode::createOrUpdateGeometry(SceneInfo* sceneInfo)
{
	if (!mPrimaryPath)
	{
		if (mContent->getGateType() == LogicGate::GateType::AND)
		{
			mPrimaryPath = std::make_unique<PathNode>(Transform(), LogicGatePrimitiveShapes::getAndGateShape());
		}
		else if (mContent->getGateType() == LogicGate::GateType::OR)
		{
			mPrimaryPath = std::make_unique<PathNode>(Transform(), LogicGatePrimitiveShapes::getOrGateShape());
		}
		
		if (mPrimaryPath)
		{
			addChild(mPrimaryPath.get());
		}	
	}
}