#include "TerminalNode.h"

#include "CircleNode.h"

TerminalNode::TerminalNode(const Transform& transform)
	: AbstractVisualNode(transform)
{

}

void TerminalNode::setContent(Terminal* terminal)
{
	mContent = terminal;
}

void TerminalNode::createOrUpdateGeometry(SceneInfo* sceneInfo)
{
	if (!mMarker)
	{
		mMarker = std::make_unique<CircleNode>(Transform{}, 5);
		mMarker->setFillColor(Color(0, 0, 0));
		mMarker->setHasStrokeColor(false);

		addChild(mMarker.get());
	}
}

void TerminalNode::update(SceneInfo* sceneInfo)
{
    if (mContentDirty)
    {
        createOrUpdateGeometry(sceneInfo);
        mContentDirty = false;
    }
}